//----------------------------------------------------------------------//
// PSPt@C̏													//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <System.StrUtils.hpp>
#include "usr_str.h"
#include "usr_wic.h"
#include "usr_file_ex.h"
#include "usr_shell.h"
#include "usr_psp.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//PSPt@C̏擾
//---------------------------------------------------------------------------
bool PSP_GetInf(
	UnicodeString fnam,		//t@C
	TStringList  *lst,		//[o] 񃊃Xg	(NULLł)
	unsigned int *i_wd,		//[o] 			(default = NULL)
	unsigned int *i_hi)		//[o] 			(default = NULL)
{
	bool ret = false;
	try {
		std::unique_ptr<TFileStream> fs(new TFileStream(fnam, fmOpenRead | fmShareDenyNone));
		if (!StartsStr(fsRead_char(fs.get(), 32), "Paint Shop Pro Image File\x0a\x1a")) Abort();
		int vno = fsRead_int4(fs.get());
		if (lst) lst->Add(get_PropTitle(_T("t@CVer.")).cat_sprintf(_T("%u.0"), vno));

		for (;;) {
			if (!SameStr(fsRead_char(fs.get(), 4), "~BK")) break;
			int tag    = fsRead_int2(fs.get());
			int len1   = fsRead_int4(fs.get());
			int len2   = fsRead_int4(fs.get());
			int next_p = fs->Seek(0, soFromCurrent) - 4;
			next_p += (tag==0x10 || tag==0x12)? len2 : len1;
			if (vno<=3) next_p += 4;

			//Image Block
			if (tag==0) {
				//TCY
				unsigned int iw = fsRead_int4(fs.get());
				unsigned int ih = fsRead_int4(fs.get());
				if (i_wd && i_hi) { *i_wd = iw; *i_hi = ih; }

				if (lst) {
					UnicodeString lbuf = get_PropTitle("摜TCY").cat_sprintf(_T("%u ~ %u"), iw, ih);
					if (iw>0 && ih>0) lbuf.cat_sprintf(_T("  (%s)"), get_AspectStr(iw, ih).c_str());
					lst->Add(lbuf);
					//𑜓x
					double r = fsRead_double(fs.get());
					BYTE b	 = fsRead_byte(fs.get());
					switch (b) {
					case 1: lst->Add(get_PropTitle(_T("pixel/inch")).cat_sprintf(_T("%g"), r)); break;
					case 2: lst->Add(get_PropTitle(_T("pixel/cm")).cat_sprintf(_T("%g"), r));	 break;
					}
					//̑
					int cmp = fsRead_int2(fs.get());
					lst->Add(make_PropLine(_T("k"), (cmp==1)? "RLE" : (cmp==2)? "LZ77" : (cmp==3)? "JPEG" : "None"));
					lst->Add(get_PropTitle(_T("Bit/Sample")).cat_sprintf(_T("%u"), fsRead_int2(fs.get())));
					fs->Seek(2, soFromCurrent);	//Planes
					lst->Add(get_PropTitle(_T("F")).cat_sprintf(_T("%u"), fsRead_int4(fs.get())));
				}
				ret = true;
				break;
			}

			fs->Seek(next_p, soFromBeginning);
		}
	}
	catch (...) {
		if (lst) lst->Clear();
	}

	return ret;
}

//---------------------------------------------------------------------------
//PSPt@C̃TlC摜擾
//---------------------------------------------------------------------------
bool PSP_GetThumbnail(
	UnicodeString fnam,			//t@C
	Graphics::TBitmap *bmpimg)	//o̓rbg}bv (default = NULL)
{

	try {
		bool ok = false;
		std::unique_ptr<TFileStream> fs(new TFileStream(fnam, fmOpenRead | fmShareDenyNone));
		if (!StartsStr(fsRead_char(fs.get(), 32), "Paint Shop Pro Image File\x0a\x1a")) Abort();
		int vno = fsRead_int4(fs.get());

		for (;;) {
			if (!SameStr(fsRead_char(fs.get(), 4), "~BK")) break;
			int tag    = fsRead_int2(fs.get());
			int len1   = fsRead_int4(fs.get());
			int len2   = fsRead_int4(fs.get());
			int next_p = fs->Seek(0, soFromCurrent) - 4;
			next_p += (tag==0x10 || tag==0x12)? len2 : len1;
			if (vno<=3) next_p += 4;

			//PreviewImage
			if (tag==0x12) {
				fs->Seek(next_p, soFromBeginning);
				std::unique_ptr<TMemoryStream> ms(new TMemoryStream());
				if (ms->CopyFrom(fs.get(), len1)==len1) {
					if (!WIC_get_from_memory(ms.get(), bmpimg, GUID_ContainerFormatJpeg)) Abort();
					ok = !bmpimg->Empty;
				}
				break;
			}

			fs->Seek(next_p, soFromBeginning);
		}
		return ok;
	}
	catch (...) {
		return false;
	}
}
//---------------------------------------------------------------------------
